ETR = LibStub("AceAddon-3.0"):NewAddon("EventTraceReloaded", "AceHook-3.0");
ETR_Frame = nil;

local AceGUI = LibStub("AceGUI-3.0");
local FrameShown = nil;
local FrameShownCounter = 0
local ETR_SimpleGrp = nil;
local scroll = nil
local WoWversion = 40300
local ETRdb = nil;

function ETR:OnInitialize()
	ETRdb = LibStub("AceDB-3.0"):New("EventTraceReloaded",nil,"Default")
end

function ETR:OnEnable()
	UIParentLoadAddOn("Blizzard_DebugTools");
	self:SecureHook("EventTraceFrame_RemoveEvent")
	self:SecureHook("EventTraceFrame_StartEventCapture")
	self:SecureHook("EventTraceFrame_HandleSlashCmd")
	
	if (ETRdb.global.startup) then
		EventTraceFrame_HandleSlashCmd("")
	end
	
	EventTraceFrame_Update();
end

-- Create the main frame
function ETR:ShowFrame()
	
	-- Prevent redrawing of the same frame
	if (not ETR_Frame or ETR_Frame:IsVisible() == nil) then
		ETR_Frame = AceGUI:Create("Frame")
		ETR_Frame:SetTitle("ETR")
		ETR_Frame:SetCallback("OnClose", function(widget) AceGUI:Release(widget)  end)
		ETR_Frame:SetLayout("Flow")
		ETR_Frame:SetWidth("250")
		ETR_Frame:SetHeight("400")
		
		-- Checkbox
		local ETRstartup_checkbox = AceGUI:Create("CheckBox")
		ETRstartup_checkbox:SetLabel("Load at start")
		ETRstartup_checkbox:SetType("checkbox")
		ETRstartup_checkbox:SetValue(ETRdb.global.startup)
		ETRstartup_checkbox:SetCallback("OnValueChanged", function() ETRdb.global.startup = ETRstartup_checkbox:GetValue() end)
		ETR_Frame:AddChild(ETRstartup_checkbox)
		
		-- Scroll container
		ETR_SimpleGrp = AceGUI:Create("SimpleGroup")
		ETR_SimpleGrp:SetFullWidth(true)
		ETR_SimpleGrp:SetFullHeight(true)
		ETR_SimpleGrp:SetLayout("Fill")
		ETR_Frame:AddChild(ETR_SimpleGrp)
		
		
		
		-- Scroll frame
		scroll = AceGUI:Create("ScrollFrame")
		scroll:SetLayout("Flow")
		ETR_SimpleGrp:AddChild(scroll)
		
		-- Load saved ignored events
		Load_Ignored_Events()
	end

	FrameShown = 1
	ETR:UpdateFrame()
end


-- Loads from DB to EventTraceFrame.ignoredEvents
function Load_Ignored_Events()
	for event,_ in pairs(ETRdb.profile) do
			if (event ~= "__orderedIndex") then
				EventTraceFrame.ignoredEvents[event] = 1
			end
	end
end

-- Iterates "EventTraceFrame.ignoredEvents" and populates the main frame
function ETR:UpdateFrame()
	scroll:ReleaseChildren()
	for i,v in orderedPairs(EventTraceFrame.ignoredEvents) do
		local editbox = AceGUI:Create("InteractiveLabel")
		editbox:SetText(i)
		--editbox:SetImage("Interface\\Battlefieldframe\\Battleground-Horde.blp")
		editbox:SetCallback("OnClick", function() 
		EventTraceFrame.ignoredEvents[i] = nil;
		ETRdb.profile[i] = nil
		EventTraceFrame_Update();
		ETR:UpdateFrame() end)
		scroll:AddChild(editbox)
	end
end
   
function ETR:EventTraceFrame_RemoveEvent(i)
	
	-- Save newly removed event
	for i,v in orderedPairs(EventTraceFrame.ignoredEvents) do
		ETRdb.profile[i] = 1
	end
	
	ETR:UpdateFrame()
end

function ETR:EventTraceFrame_StartEventCapture()
	-- Load saved ignored events
	Load_Ignored_Events()

	FrameShown = 1
	ETR:ShowFrame()
end


-- Slash command listener
function ETR:EventTraceFrame_HandleSlashCmd(msg)
	if (not msg) then
	  print("ERROR!")
	  return
	end

	msg = strlower(msg);
	if ( msg == "start" ) then
		FrameShown = 1
		ETR:EventTraceFrame_StartEventCapture()
	elseif ( msg == "stop" ) then
		--print("Event frame hidden!")
		FrameShown = nil 
	elseif (tonumber(msg) and tonumber(msg) > 0 ) then
		FrameShown = 1
		ETR:EventTraceFrame_StartEventCapture()
	elseif ( msg == "" ) then
		FrameShownCounter = FrameShownCounter + 1;
		
		-- Toggle
		if (FrameShownCounter == 1) then
			-- First time loading
			FrameShown = 1
			ETR:EventTraceFrame_StartEventCapture()
		else
			if (FrameShown) then
				FrameShown = nil
				--print("Event frame hidden!!")
			else
				FrameShown = 1
				ETR:EventTraceFrame_StartEventCapture()
			end
		end
	end
end